﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MetroFramework.Forms;
namespace Basic_Terminal
{
    public enum BluecellLayer_t
    {
        bluecell_init = 0,
        bluecell_terminal ,
        bluecell_operate,
        bluecell_update,
        bluecell_about,
        bluecell_config,
        bluecell_lastlayer,
    };
    public partial class Menu : Form
    {
        private int Curr_Layer;
        private int Pre_Layer;

        int[] panelWidth = new int[(int)BluecellLayer_t.bluecell_lastlayer];
        bool[] Hidden = new bool[(int)BluecellLayer_t.bluecell_lastlayer];
        int [] temp_panelWidth = new int[(int)BluecellLayer_t.bluecell_lastlayer];
        MetroFramework.Controls.MetroPanel main_panel;// = new MetroFramework.Controls.MetroPanel[(int)BluecellLayer_t.bluecell_lastlayer];
        private void bool_init(ref bool[] data,int size,bool set)
        {
            for(int i = 0; i < size; i++)
            {
                data[i] = set;
            }

        }
        private void int_init(ref int[] data, int size, int set)
        {
            for (int i = 0; i < size; i++)
            {
                data[i] = set;
            }

        }
        public Menu()
        {
            InitializeComponent();
            bool_init(ref Hidden, (int)BluecellLayer_t.bluecell_lastlayer, true);
            int_init(ref panelWidth, (int)BluecellLayer_t.bluecell_lastlayer, metroPanel_Terminal.Width);
            temp_panelWidth[(int)BluecellLayer_t.bluecell_about] = 0;//metroPanel_about.Width;
            temp_panelWidth[(int)BluecellLayer_t.bluecell_operate] = 0;// metroPanel_Operate.Width;
            temp_panelWidth[(int)BluecellLayer_t.bluecell_update] = 0;//metroPanel_update.Width;
            temp_panelWidth[(int)BluecellLayer_t.bluecell_terminal] = 0;// metroPanel_Terminal.Width;
            temp_panelWidth[(int)BluecellLayer_t.bluecell_config] = 0;//metroPanel_config.Width;
            metroPanel_about.Visible = false;
            metroPanel_Operate.Visible = false;
            metroPanel_update.Visible = false;
            metroPanel_Terminal.Visible = false;
            metroPanel_config.Visible = false;
            /*    Metro_FontSize_Control(metroTile_terminal, MetroFramework.MetroTileTextSize.Tall);
                Metro_FontSize_Control(metroTile_operate, MetroFramework.MetroTileTextSize.Tall);
                Metro_FontSize_Control(metroTile_update, MetroFramework.MetroTileTextSize.Tall);
                Metro_FontSize_Control(metroTile_about, MetroFramework.MetroTileTextSize.Tall);
                Metro_FontSize_Control(metroTile_quit, MetroFramework.MetroTileTextSize.Tall);
                Metro_FontSize_Weight(metroTile_terminal, MetroFramework.MetroTileTextWeight.Regular);
                Metro_FontSize_Weight(metroTile_operate, MetroFramework.MetroTileTextWeight.Regular);
                Metro_FontSize_Weight(metroTile_update, MetroFramework.MetroTileTextWeight.Regular);
                Metro_FontSize_Weight(metroTile_about, MetroFramework.MetroTileTextWeight.Regular);
                Metro_FontSize_Weight(metroTile_quit, MetroFramework.MetroTileTextWeight.Regular);*/

        }
        private void Metro_FontSize_Control(object target, MetroFramework.MetroTileTextSize size)
        {
            MetroFramework.Controls.MetroTile metro_target;
            metro_target  = (MetroFramework.Controls.MetroTile)target;
            metro_target.TileTextFontSize = size;
        }
        private void Metro_FontSize_Weight(object target, MetroFramework.MetroTileTextWeight weight)
        {
            MetroFramework.Controls.MetroTile metro_target;
            metro_target = (MetroFramework.Controls.MetroTile)target;
            metro_target.TileTextFontWeight = weight;
        }
        private void label_WndMin_Click(object sender, EventArgs e)
        {

        }

        private void label_WndClose_Click(object sender, EventArgs e)
        {

        }

        private void Menu_MouseUp(object sender, MouseEventArgs e)
        {
          
        }
        public const int WM_NCLBUTTONDOWN = 0xA1;
        public const int HT_CAPTION = 0x2;

        public int Curr_Layer1 { get => Curr_Layer; set => Curr_Layer = value; }
        public int Pre_Layer1 { get => Pre_Layer; set => Pre_Layer = value; }

        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern int SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);
        [System.Runtime.InteropServices.DllImportAttribute("user32.dll")]
        public static extern bool ReleaseCapture();
        private void Menu_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                ReleaseCapture();
                SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0);
            }
        }



        private void button_MIN_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }



        private void metroTile_MouseLeave(object sender, EventArgs e)
        {
            MetroFramework.Controls.MetroTile metroTile = (MetroFramework.Controls.MetroTile)sender;
            metroTile.BackColor = Color.FromArgb(0, 159, 200);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
      
        }

        private void metroTile_MouseMove(object sender, MouseEventArgs e)
        {
            MetroFramework.Controls.MetroTile metroTile = (MetroFramework.Controls.MetroTile)sender;
            metroTile.BackColor = Color.FromArgb(0, 159, 255);
        }

        private void metroTile_quit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void metroTile_config_Click(object sender, EventArgs e)
        {

            Curr_Layer1 = (int)BluecellLayer_t.bluecell_config;
            main_panel = metroPanel_config;
            metroPanel_config.Width = temp_panelWidth[(int)BluecellLayer_t.bluecell_config]; 
            metroPanel_about.Visible   = false;
            metroPanel_Operate.Visible = false;
            metroPanel_update.Visible  = false;
            metroPanel_Terminal.Visible = false;
            metroPanel_config.Visible = true;

            timer1.Start();
        }

        private void metroTile_about_Click(object sender, EventArgs e)
        {
            Curr_Layer1 = (int)BluecellLayer_t.bluecell_about;
            main_panel = metroPanel_about;
            metroPanel_about.Width = temp_panelWidth[(int)BluecellLayer_t.bluecell_about];
            metroPanel_about.Visible = true;
            metroPanel_Operate.Visible = false;
            metroPanel_update.Visible = false;
            metroPanel_Terminal.Visible = false;
            metroPanel_config.Visible = false;

            timer1.Start();
        }

        private void metroTile_update_Click(object sender, EventArgs e)
        {
            Curr_Layer1 = (int)BluecellLayer_t.bluecell_update;
            main_panel = metroPanel_update;
            metroPanel_update.Width = temp_panelWidth[(int)BluecellLayer_t.bluecell_update];
            metroPanel_about.Visible = false;
            metroPanel_Operate.Visible = false;
            metroPanel_update.Visible = true;
            metroPanel_Terminal.Visible = false;
            metroPanel_config.Visible = false;
            timer1.Start();
        }

        private void metroTile_operate_Click(object sender, EventArgs e)
        {
            Curr_Layer1 = (int)BluecellLayer_t.bluecell_operate;
            main_panel = metroPanel_Operate;
            metroPanel_Operate.Width = temp_panelWidth[(int)BluecellLayer_t.bluecell_operate];
            metroPanel_about.Visible = false;
            metroPanel_Operate.Visible = true;
            metroPanel_update.Visible = false;
            metroPanel_Terminal.Visible = false;
            metroPanel_config.Visible = false;
            timer1.Start();
        }

        private void metroTile_terminal_Click(object sender, EventArgs e)
        {
            Curr_Layer = (int)BluecellLayer_t.bluecell_terminal;
            main_panel = metroPanel_Terminal;
            metroPanel_Terminal.Width = temp_panelWidth[(int)BluecellLayer_t.bluecell_terminal];
            metroPanel_about.Visible = false;
            metroPanel_Operate.Visible = false;
            metroPanel_update.Visible = false;
            metroPanel_Terminal.Visible = true;
            metroPanel_config.Visible = false;
            timer1.Start(); 
                        //MetroFramework.Controls.MetroTile metroTile = (MetroFramework.Controls.MetroTile)sender;
        }

        private void pictureBox_X_MouseMove(object sender, MouseEventArgs e)
        {
            pictureBox_X.Visible = false;
            pictureBox_X_RED.Visible = true;
        }

        private void pictureBox_X_RED_MouseLeave(object sender, EventArgs e)
        {
            pictureBox_X.Visible = true;
            pictureBox_X_RED.Visible = false;
        }

        private void pictureBox_min_red_MouseLeave(object sender, EventArgs e)
        {
            pictureBox_min.Visible = true;
            pictureBox_min_red.Visible = false;
        }

        private void pictureBox_min_MouseMove(object sender, MouseEventArgs e)
        {
            pictureBox_min.Visible = false;
            pictureBox_min_red.Visible = true;
        }
        
        private void timer1_Tick_1(object sender, EventArgs e)
        {
            picture_animation(main_panel, Curr_Layer);
        /*   picture_animation(metroPanel_about, Curr_Layer);
            picture_animation(metroPanel_Operate, Curr_Layer);
            picture_animation(metroPanel_config, Curr_Layer);
            picture_animation(metroPanel_Terminal, Curr_Layer);*/
            //picture_animation();
        }

        private void picture_animation(object sender,int index)
        {
            MetroFramework.Controls.MetroPanel panel = (MetroFramework.Controls.MetroPanel)sender;
            if (Hidden[index])
            {
                panel.Width = panel.Width + 30;
                if (panel.Width >= panelWidth[index])
                {
                    timer1.Stop();
                    Pre_Layer = index;
                    Hidden[index] = false;
                    this.Refresh();
                }
            }
            else
            {
                panel.Width = 0;
                Hidden[index] = true;
                /*
                panel.Width = panel.Width - 30;
                if (panel.Width <= 0)
                {
                    timer1.Stop();
                    Hidden[index] = true;
                    this.Refresh();
                }
                */
            }
        }


        private void pictureBox_min_red_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Minimized;
        }

        private void MetroTile_portclose_Click(object sender, EventArgs e)
        {
            metroTile_portclose.Visible = false;
            metroTile_portopen.Visible = true;
        }

        private void MetroTile_portopen_Click(object sender, EventArgs e)
        {
            metroTile_portclose.Visible = true;
            metroTile_portopen.Visible = false;
        }


        /*
private void label_WndMin_MouseHover(object sender, EventArgs e)
{
label_WndMin.ForeColor = Color.FromArgb(255, 255, 0);
}

private void label_WndClose_MouseHover(object sender, EventArgs e)
{
label_WndClose.ForeColor = Color.FromArgb(255, 255, 0);
}

private void label_WndClose_MouseLeave(object sender, EventArgs e)
{
label_WndMin.ForeColor = Color.FromArgb(255, 255, 255);
}

private void label_WndMin_MouseLeave(object sender, EventArgs e)
{
label_WndMin.ForeColor = Color.FromArgb(255, 255, 255);
}
*/
    }
    public static class Util
    {
        public enum Effect { Roll, Slide, Center, Blend }

        public static void Animate(Control ctl, Effect effect, int msec, int angle)
        {
            int flags = effmap[(int)effect];
            if (ctl.Visible) { flags |= 0x10000; angle += 180; }
            else
            {
                if (ctl.TopLevelControl == ctl) flags |= 0x20000;
                else if (effect == Effect.Blend) throw new ArgumentException();
            }
            flags |= dirmap[(angle % 360) / 45];
            bool ok = AnimateWindow(ctl.Handle, msec, flags);
            if (!ok) throw new Exception("Animation failed");
            ctl.Visible = !ctl.Visible;
        }

        private static int[] dirmap = { 1, 5, 4, 6, 2, 10, 8, 9 };
        private static int[] effmap = { 0, 0x40000, 0x10, 0x80000 };

        [DllImport("user32.dll")]
        private static extern bool AnimateWindow(IntPtr handle, int msec, int flags);
    }
}
